/*
 * sort.c
 */

#include <stdio.h> 
#include <stdlib.h>

#define MAXLIN 5000
#define TAMMAX 1000

char *ptrlinha[MAXLIN];

int lelinhas(char *ptrlinha[], int nlinhas);
void imprlinhas(char *ptrlinha[], int nlinhas);
int lelinha(char linha[], int lim);
void sort(char *ptrlinha[]);
int strcmp(const char s1[], const char s2[]);

main()
{
    int nlinhas;
    if((nlinhas=lelinhas(ptrlinha,MAXLIN)) >=0){
	sort(ptrlinha);
	imprlinhas(ptrlinha,nlinhas);
	return 0;
    }
    else{
	printf("Erro\n");
	return 1;
    }
}

int lelinha(char s[], int lim)
{
    int c,i;

    for (i=0; i<lim-1 && (c=getchar())!=EOF && c!= '\n'; ++i)
	s[i]=c;
    if (c == '\n'){
	s[i]=c;
    	++i;
    }
    s[i] = '\0';
    return i;
}

int lelinhas(char *ptrlinha[], int maxlin)
{
    int tam,nlinhas;

    char *p,linha[TAMMAX];

    nlinhas=0;
    while((tam=lelinha(linha,TAMMAX))>0)
	if (nlinhas >= maxlin || (p=(char *)malloc(tam)) == NULL)
	    return -1;
	else{
	    linha[tam-1]='\0';
	    strcpy(p,linha);
	    ptrlinha[nlinhas++]=p;
	}
    return nlinhas;
}

void imprlinhas(char *ptrlinha[],int nlinhas)
{
    int i;

    for (i=0; i<nlinhas; i++)
	printf("%s\n",ptrlinha[i]);
}

void sort(char *ptrlinha[])
{
    int i,j;
    char *ptemp;

    for(i=0; ptrlinha[i+1] != NULL; ++i)
	for(j=i+1; ptrlinha[j] != NULL; ++j)
	    if(strcmp(ptrlinha[i],ptrlinha[j]) > 0) {
		ptemp = ptrlinha[i];
		ptrlinha[i] = ptrlinha[j];
		ptrlinha[j] = ptemp;
	    }
}

int strcmp(const char s1[], const char s2[])
{
    while (*s1 != '\0' && *s2 != '\0') {
	if (*s1 != *s2)
	    return *s1 - *s2;
	s1++;
	s2++;
    }

    if (*s1 == '\0')
	return -1;
    else
	return 1;
}

/*
 * EOF
 */
